/*
 * command_driver.c
 *
 * These routines handles the actual finding and execution of commands.
 * It is called from cmdhooks.c in the living object that performs the
 * command.
 */

#include </secure/std.h>

static mapping	cmdlist;		/* The list of verbs and functions */

static int command_loaded;		/* Flag to remember of the verbs
					   and functions are loaded or not */

/* 
 * Function name: do_command
 * Description:   Perform the given command, if present.
 * Returns:	  1/0 depending on success.
 */
nomask int
do_command(string verb, string arg)
{
    string func;

    if (m_sizeof(cmdlist) == 0)
	return 0;

    func = cmdlist[verb];

    if (strlen(func) != 0)
	return ((int)call_other(this_object(), func, arg));
    else
	return 0;
}

/* 
 * Function name: exist_command
 * Description:   Check if a command exists.
 * Returns:	  1/0 depending on success.
 */
nomask int
exist_command(string verb)
{
    if (!command_loaded)
    {
	cmdlist = (mapping)this_object()->query_cmdlist();
	command_loaded = 1;
    }

    if (strlen(cmdlist[verb]))
	return 1;
    else
	return 0;
}

/*
 * Function name: open_soul
 * Description:   Set the euid of the soul to 0.
 */
nomask void
open_soul(int state)
{
    if (state)
	seteuid(getuid(this_object()));
    else
    {
	SECURITY->remote_setuid();
	seteuid(0);
    }
}


/*
 * Function name: teleledningsanka
 * Description:   This function is used to load a soul and in command
 *		  souls also to set the uid, euid to "backbone".
 */
void
teleledningsanka()
{
    seteuid(0);
    SECURITY->remote_setuid();
    seteuid(getuid(this_object()));
}
