/* Tintin 930111

   This object stores information about the filename of the latest note
   of each board in the game. Since the filename consists of the letter
   'b' followed by a string of digits that constitute the creation time of the
   note as received from time(), you can easily find out the time of the
   latest note on each board.
*/
#define SAVE_FILE "/open/board_central"
mapping boards;

void
create()
{
    seteuid(getuid());
    if (!restore_object(SAVE_FILE))
	boards = ([ ]);
}

int
remove_object()
{
    destruct(this_object());
    return 1;
}

void
new_note(string board_name, string file_name)
{
    if (file_name)
	boards[board_name] = file_name;
    else
	boards = m_delete(boards, board_name);
    save_object(SAVE_FILE);
}

mapping
query_all_boards()
{
    return boards;
}

string
query_board(string filename)
{
    return boards[filename];
}
