/* 
 * /std/living/wizstat.c
 *
 * Contains the code to implement the various wizardly information commands.
 */

/*
 * Description: Give status for this living.
 */
public string stat_living()
{
    string str;
    PROFILE("stat_living");

    str = sprintf(
		  "Name: %15s(%-15s   Race: %-10s    Gender: %-10s\n" +
	          "File: %-31s   Uid:  %-10s    Euid:   %-10s\n"  +
		  "------------------------------------------------------" +
		  "----------------------\n" +
		  "Exp: %-7d    Expquest: %-7d    Hp: %4d(%4d) " +
		  " Mana: %4d(%4d)\n" +  
		  "Fatigue: %7d(%7d)   Weight: %7d(%7d)    Volume: %7d(%7d)\n" +
		  "Stats:     %@7s\n"  +
                  "    Val:   %@7d\n" +
                  "    Acc:   %@7d\n" +
	          "  Learn:   %@7d\n" +
		  "Skills are shown by the command 'skillstat'\n" +
		  "Intox: %-6d  Headache: %-3d  Stuffed: %-3d Soaked: %-3d  " +
		  "Align: %d\n" +
		  "Scar:  %-6d  Ghost:    %-3d  Invis:   %-3d Npc:    %-3d  " +
		  "Wiz: %d  Whimpy: %d\n"
		  ,
		  query_name(), query_real_name()+")", query_race_name(),
		  query_gender_string(),
		  file_name(this_object()), getuid(this_object()),
		  geteuid(this_object()),
		  query_exp(), query_exp() - query_exp_combat(),
		  query_hp(), query_max_hp(),
		  query_mana(), query_max_mana(),
		  query_fatigue(), query_max_fatigue(),
		  query_prop(OBJ_I_WEIGHT), query_prop(CONT_I_MAX_WEIGHT),
		  query_prop(OBJ_I_VOLUME), query_prop(CONT_I_MAX_VOLUME),
		  SS_STAT_DESC,
		  ({ query_stat(SS_STR), query_stat(SS_DEX), query_stat(SS_CON),
		     query_stat(SS_INT), query_stat(SS_WIS), query_stat(SS_DIS),
		     query_stat(SS_RACE), query_stat(SS_GUILD),
		     query_stat(SS_OTHER) }),
		  ({ query_acc_exp(SS_STR), query_acc_exp(SS_DEX),
		     query_acc_exp(SS_CON), query_acc_exp(SS_INT),
		     query_acc_exp(SS_WIS), query_acc_exp(SS_DIS),
		     query_acc_exp(SS_RACE), query_acc_exp(SS_GUILD),
		     query_acc_exp(SS_OTHER) }),
		  query_learn_pref(-1),
		  query_intoxicated(), query_headache(), query_stuffed(),
		  query_soaked(), query_alignment(),
		  query_scar(), query_ghost(), query_invis(), query_npc(),
		  query_wiz_level(), query_whimpy()
		  );

    return str;
}


public string
skill_living()
{
    string str, *skills, sk;
    int *sktypes, i;
    mapping sk_desc;

    PROFILE("skill_living");
    sk_desc = SS_SKILL_DESC;

    sktypes = query_all_skill_types();
    sk = "";

    if (sizeof(sktypes))
    {
	skills = map(sktypes, "fix_skill_desc", this_object(), sk_desc);
	for(i = 0; i < sizeof(skills); i += 2)
	{
	    sk += sprintf("%#30s", skills[i]);
	    if(i + 1 < sizeof(skills))
		sk += sprintf("%#30s", skills[i + 1]) + "\n";
	}
	sk += "\n";
    } else
	sk = "   None\n";
    
    str = sprintf(
		  "Name: %15s\n" +
		  "Skills:\n" + sk,
		  query_name()
		  );

    return str;
}

static string
fix_skill_desc(int sktype, mapping sk_desc)
{
    mixed *skarr;
    PROFILE("fix_skill_desc");

    skarr = sk_desc[sktype];

/* query_skill() can be shadowed and if we want it to work fine
 * we must use this_object()-> instead of calling it internally.
 */
    if (pointerp(skarr))
	return sprintf("%12s %3d", skarr[0] + ":",
		this_object()->query_skill(sktype));
    else
	return sprintf("<num %-5d>: %3d", sktype,
		this_object()->query_skill(sktype));
}
