/*
  /sys/language.h

  Some language functions

*/

#ifndef LANG_DEF
#define LANG_DEF

#define LANG_FILE "/sys/global/language"

/* LANG_PWORD  -- Get the plural form of a noun
*/
/* LANG_SWORD  -- Get the singular form of a noun
*/
/* LANG_PSENT  -- Get the plural form of a noun phrase
*/
/* LANG_ART    -- Get the article of a noun
*/
/* LANG_ADDART -- Get the article of a noun + the noun
*/
/* LANG_WNUM   -- Get the textform of a number
*/
/* LANG_NUMW   -- Get the number of a textform
*/
/* LANG_POSS   -- Get the possessive form of a name
*/
/* LANG_ASHORT -- Get it right with article and heaps
*/
/* LANG_THESHORT -- Get it right with 'the' in front of heaps
*/
/* LANG_ORDW    -- Get the number of an ordinal textform, "first" -> 1
*/
/* LANG_WORD    -- Get the text in ordinal from from a number, 2 -> "second"
*/

#define LANG_PWORD(x) call_other(LANG_FILE, "plural_word", x)
#define LANG_SWORD(x) call_other(LANG_FILE, "singular_form", x)
#define LANG_PSENT(x) call_other(LANG_FILE, "plural_sentence", x)
#define LANG_ART(x) call_other(LANG_FILE, "article", x)
#define LANG_ADDART(x) call_other(LANG_FILE, "add_article", x)
#define LANG_WNUM(x) call_other(LANG_FILE, "word_number", x)
#define LANG_NUMW(x) call_other(LANG_FILE, "number_word", x)
#define LANG_POSS(x) call_other(LANG_FILE, "name_possessive", x)
#define LANG_ASHORT(x) call_other(LANG_FILE, "lang_a_short", x)
#define LANG_THESHORT(x) call_other(LANG_FILE, "lang_the_short", x)
#define LANG_ORDW(x) call_other(LANG_FILE, "number_ord_word", x)
#define LANG_WORD(x) call_other(LANG_FILE, "word_ord_number", x)

/* Alternate use:
 *
 * -- Get the plural form of a noun		LANG_FILE->plural_word(x)
 * -- Get the singluar form of a noun		LANG_FILE->singular_form(x)
 * -- Get the plural form of a noun phrase	LANG_FILE->plural_sentence(x)
 * -- Get the article of a noun			LANG_FILE->article(x)
 * -- Get the article of a noun + the noun	LANG_FILE->add_article(x)
 * -- Get the textform of a number		LANG_FILE->word_number(x)
 * -- Get the number of a textform		LANG_FILE->number_word(x)
 * -- Get the possessive form of a name         LANG_FILE->name_possessive(x)
 */
#endif
