
/*
   Specific gravities:  Copper: 8.9, Silver: 10.5, Gold: 19.3, Platinum: 21.4
*/

#include "/config/sys/money2.h"

/*
 * Documentation for functions can be found in this file:
 */
#define MONEY_FN "/sys/global/money.c"

/*
 *
 * These macros can be used, but you might as well do:
 * MONEY_FN->func_name(....params....)
 * 
 * Which might be more readable!
 */

#define MONEY_COINS(ob) call_other(MONEY_FN, "what_coins", ob)

#define MONEY_SPLIT(cp) call_other(MONEY_FN, "split_values", cp)
#define MONEY_MERGE(carr) call_other(MONEY_FN, "merge_values", carr)

#define MONEY_MOVE(num, ctype, from, to) \
  call_other(MONEY_FN, "move_coins", ctype, num, from, to)

#define MONEY_MAKE(num, ctype) \
  call_other(MONEY_FN, "make_coins", ctype, num)

#define MONEY_MAKE_CC(num) call_other(MONEY_FN, "make_coins", "copper", num)
#define MONEY_MAKE_SC(num) call_other(MONEY_FN, "make_coins", "silver", num)
#define MONEY_MAKE_GC(num) call_other(MONEY_FN, "make_coins", "gold", num)
#define MONEY_MAKE_PC(num) call_other(MONEY_FN, "make_coins", "platinum", num)

#define MONEY_MOVE_CC(num, from, to) \
	call_other(MONEY_FN, "move_coins", "copper", num, from, to)
#define MONEY_MOVE_SC(num, from, to) \
	call_other(MONEY_FN, "move_coins", "silver", num, from, to)
#define MONEY_MOVE_GC(num, from, to) \
	call_other(MONEY_FN, "move_coins", "gold", num, from, to)
#define MONEY_MOVE_PC(num, from, to) \
	call_other(MONEY_FN, "move_coins", "platinum", num, from, to)

#define MONEY_IN(obj) call_other(MONEY_FN, "what_coins", obj)

#define MONEY_ADD(who, amount) MONEY_FN->add_money(who, amount)
